//2010 0.1 Copyright (C) Michael Niedermayer 1998

#include <stdlib.h>
#include <pc.h>
#include <stdio.h>
#include <dpmi.h>
#include <string.h>
#include <sys/nearptr.h>
#include <unistd.h>
#include <conio.h>
#include <crt0.h>
#include <signal.h>
#include "2_all.h"
#include "2010.h"
#include "2_hw.h"
#include "2_hw_mem.h"
#include "2_mouse.h"
#include "2_file.h"
#include "2_menu.h"
#include "2_grafix.h"
#include "2_71x6.h"

 extern mouse_sprites cursor;
 extern int g_mode;
 extern xxx dispbuf, grab_dispbuf;
 extern byte *vidbuf;
 extern int mouse_x, mouse_y, mouse_b;
 extern volatile int page_flip;
 extern int xres, yres, xresvb, xresc, vb, mc;
 extern int active_meteor;
 extern int me, mx, my;
 extern int yuvmode;
 extern byte *mouse_buff[2];
 extern int single;
 extern int grabf;
 extern int mmx;

int _crt0_startup_flags = _CRT0_FLAG_NEARPTR | _CRT0_FLAG_NONMOVE_SBRK;
 int buttons=0, xpos=0, ypos=0, lxpos=0, lypos=0;
 int fysize;
 byte font[4096];
 int NoInt8=0;
 int vid=0;
 int bpp;
 char *yuv2rgb_lut;
 int edge_lut[256];

void printg_t(char *text){
 close_hw();
 printf(text);
}

int error(error_code e){
// asm("int $3\n\t");
 switch(e){
  case Lock        : printg_t("\nError (Un)Locking Linear Region!\n");
                     break;
  case NoVDS       : printg_t("\nVDS Not Detected!\n");
                     break;
  case VDS         : printg_t("\nVDS Error!\n");
                     break;
  case NoVESA      : printg_t("\nVESA Not Detected!\n");
                     break;
  case FileRead    : printg_t("\nFile-Read Error!\n");
                     break;
  case Map         : printg_t("\nCannot Map Physical Address!\n");
                     break;
  case VESA        : printg_t("\nError initalizing VESA Mode!\n");
                     break;
  case VESAFlip    : printg_t("\nPage Fliping Error!\n");
                     break;
  case VESAVer     : printg_t("\nError 2010 needs at least VESA 2.0!\n");
                     break;
  case NoMeteor    : printg_t("\nMeteor Not Detected!\n");
                     break;
  case DPMI        : printg_t("\nDPMI Error!\n");
                     break;
  case NoMouse     : printg_t("\nNo Mouse?!\n");
                     break;
  case MouseHand   : printg_t("\nMouse Handler error!\n");
                     break;
  case NoFont      : printg_t("\nNo 2010.Fnt?!\n");
                     break;
  case Font        : printg_t("\n2010.Fnt is damaged!\n");
                     break;
  case NoCursor    : printg_t("\nNo 2010.Cur?!\n");
                     break;
  case Cursor      : printg_t("\n2010.Cur is damaged!\n");
                     break;
  case FileWrite   : printg_t("\nFile-Write Error!\n");
                     break;
  case MemAlloc    : printg_t("\nMemory allocation error!\n");
                     break;
  case SAA7196     : printg_t("\nPhilips SAA7196 error!\n");
                     break;
  case CommLine    : printg_t("\nCommand-Line error!\n");
  case Help        : printg_t("\n2010 [<optons>]\n"
                            "options: -v n (Video-mode)\n"
                            "         -m n (Meteor Card) in case there are more than 1 (:\n"
                            "         -NoFlip (Disable Page-Fliping)\n"
                            "         -NoInt8 (Disable Int8-Handler)\n"
                            "         -NoMMX  (Disable MMX-Support)\n"
                            "         -? / -h (This stuff)\n");
                     break;
  default          : printg_t("\nUnknown error!");
                     break;
 }

 exit(e);
}

void exitt(void){
 close_hw();
}

int main(int argc, char **argv){
 int NoFlip=0;
 int key;
 int i, j;
 char buf[256];
 __dpmi_regs r;
 ModeInfoBlock *mib;
 VesaInfoBlock *vib;
 FILE *f;
 int mc2;

 printf("2010 0.10 Copyright (C) Michael Niedermayer 1998\n");

 atexit(exitt);

 signal(SIGABRT, sig_handler);
 signal(SIGFPE , sig_handler);
 signal(SIGILL , sig_handler);
 signal(SIGINT , sig_handler);
 signal(SIGSEGV, sig_handler);
 signal(SIGTRAP, sig_handler);

 for(i=1;i<argc;i++){
  if(stricmp(argv[i],"-v")==0){
   i++;
   sscanf(argv[i],"%d",&vid);
  }
  else if(stricmp(argv[i],"-m")==0){
   i++;
   sscanf(argv[i],"%d",&active_meteor);
  }
  else if(stricmp(argv[i],"-NoFlip")==0){
   NoFlip=1;
  }
  else if(stricmp(argv[i],"-NORGB")==0){
   yuvmode=2;
  }
  else if(stricmp(argv[i],"-Single")==0){
   single=1;
  }
  else if(stricmp(argv[i],"-NoInt8")==0){
   NoInt8=1;
  }
  else if(stricmp(argv[i],"-NoMMX")==0){
   mmx=0;
  }
  else if(stricmp(argv[i],"-?")==0 || stricmp(argv[i],"-H")==0){
   error(Help);
  }
/*  else if(stricmp(argv[i],"-v")==0){
   i++;
   if(stricmp(argv[i],"vid")==0) std=vid;
   else if(stricmp(argv[i],"nagra")==0) std=nagra;
   else error(CommLine);
  } */
  else error(CommLine);
 }

 if(check_mmx()==0) mmx=0;
 else{
  printf("MMX Detected!\n");
  if(mmx==0) printf(" but not used because -NoMMX\n");
 }

 printf("2010.Fnt...\n");
 if((f=fopen("2010.fnt", "rb"))==NULL) error(NoFont);
 fysize=fsize(f)>>8;
 if(fysize==0) error(Font);
 for(i=0; i<256; i++) fread(font+(i<<4),1,fysize,f);
 fclose(f);
 
 printf("2010.Cur...\n");
 if((f=fopen("2010.cur", "rb"))==NULL) error(NoCursor);
 cursor.x=fgetc(f);
 cursor.y=fgetc(f);
 cursor.hotx=fgetc(f);
 cursor.hoty=fgetc(f);
 cursor.z=fgetc(f);            //ERROR could be readed in struct direct
 if(cursor.x*cursor.y*cursor.z!=fsize(f)-5) error(Cursor);
 cursor.data=new byte[cursor.x*cursor.y*cursor.z];
 fread(cursor.data, 1, cursor.x*cursor.y*cursor.z, f);
 fclose(f);

 mouse_buff[0]=new byte[cursor.x * cursor.y << 2];
 mouse_buff[1]=new byte[cursor.x * cursor.y << 2];
  
 i=scan_pci_meteors();
 if(i==0) error(NoMeteor);
 if(active_meteor>=i) active_meteor=0;
 printf("%d Meteor(s) Detected!\n", i);

 for(i=0; i<256; i++){
   j=i-2;
   if(j<0) j=0;

        if(j>5 ) j=(j>>1) + 3;
   else if(j>10) j=(j>>2) + 7;
   else if(j>20) j=13;

   edge_lut[i]=j;
 }

 printf("Building YUV to RGB LookUp Tables!\n");
 yuv2rgb_lut=new char[256*4*2];
 for(i=0; i<256; i++){
   if(i>=128) j=i-256;
   else j=i;
   double d= double(j);

   yuv2rgb_lut[(i<<2)       ]= short( d * ( 1.734375) * 0.5 );
   yuv2rgb_lut[(i<<2) + 1   ]= short( d * (-0.34375 ) * 0.5 )
                             + is_pos(yuv2rgb_lut[(i<<2)       ]);
   yuv2rgb_lut[(i<<2) + 2   ]= is_pos(yuv2rgb_lut[(i<<2) + 1   ]);
   yuv2rgb_lut[(i<<2) + 3   ]= 0;

   yuv2rgb_lut[(i<<2) + 1024]= 0;
   yuv2rgb_lut[(i<<2) + 1025]= short( d * (-0.703125) * 0.5  );
   yuv2rgb_lut[(i<<2) + 1026]= short( d * ( 1.375   ) * 0.5  )
                             + is_pos(yuv2rgb_lut[(i<<2) + 1025]);
   yuv2rgb_lut[(i<<2) + 1027]= 0;
 }

 if((vib=get_vesa_info())==0) error(NoVESA);
 if(vib->ver < 0x200) error(VESAVer);
 if(vid==0){
  printf("VESA %d.%d detected!\n", (vib->ver>>8) & 255, vib->ver & 255);
 

  for(i=256;i<512;i++){
   if((mib=get_mode_info(i))!=0){
    if((mib->ModeAttrib & (8+16+128))==8+16+128 && (mib->bpp==24 || mib->bpp==32)
                      && mib->model==6 && (mib->Xres & 0x3F8) == mib->Xres
                                       && (mib->Yres & 0x3FF) == mib->Yres){
                                       // FIX ME 3FF statt 3F8 OK?
     printf("%d = %dx%dx%d",i,mib->Xres,
                              mib->Yres,
                              mib->bpp);
     if(mib->pages==0 || NoFlip==1) printf(" No Page Flipping!");
     printf("\n");
    }
   }
  }
  printf("Input Video-Mode Num:\n");
  buf[0]=255;
  sscanf((char*)cgets(buf),"%d",&vid);
  printf("\n");
 }
 

 if((mib=get_mode_info(vid))==0) error(VESA);
 if(!((mib->ModeAttrib & (8+16+128))==8+16+128 && (mib->bpp==24 || mib->bpp==32)
                      && mib->model==6 && (mib->Xres & 0x3F8) == mib->Xres
                                       && (mib->Yres & 0x3FE) == mib->Yres))
                                                    error(VESA);


 xres=mib->Xres;
 yres=mib->Yres;
 if(yuvmode!=0) mc=1;
 else mc=2;
 if(yuvmode==2) mc2=1;
 else mc2=2;
 xresc=xres<<mc;
 bpp=mib->bpp;
 vb=bpp>>3;
 xresvb=xres*vb;
 if(mib->pages>0 && NoFlip==0) page_flip=1;
 else page_flip=0;

 printf("Allocating Physical Continous Buffers...\n");

               dispbuf     =alloc_cont(xres * yres << mc2);
 if(single==0) grab_dispbuf=alloc_cont(xres * yres << mc2);
 else grab_dispbuf=dispbuf;

 if(page_flip==0) i= xres * yres * vb;
 else             i= xres * yres * vb << 1;

 vidbuf=(byte*)( map(mib->PhysBase, mib->PhysBase+i) - __djgpp_base_address);
  
 r.x.ax=0x4F02;
 r.x.bx=vid | 16384;
 __dpmi_int(0x10,&r);
 if(r.x.ax!=0x4F) error(VESA);
 g_mode=1;
  
 setmenu();
 init_hw();
 init_meteor();
 setmpos();

 key=0;
 while(key==0){
  draw_dispbuf();
 
  xpos=mouse_x;
  ypos=mouse_y;
  buttons=mouse_b;
 
  m_buttons();
 
  lxpos=xpos;
  lypos=ypos;

  if(kbhit()) key=getkey();
  if(key=='g' || key=='G') key=0, grabf=1;
 }
 
 exit(0);
}
