//2010 0.1 Copyright (C) Michael Niedermayer 1998

#include <string.h>
#include "2_all.h"
#include "2_crypt.h"
#include "2_vc.h"
#include "2_nag.h"
#include "2_71x6.h"

extern volatile tv_form std;
extern volatile crypt_form crypt;
extern xres, yres, xress, yress, y_field, yresst, yrest;
extern xxx dispbuf;
extern volatile int scales_x, scalee_x;
extern volatile int scales_y, scalee_y;
extern int one_field, v_smooth, yuvmode;
extern int satur;

static void vsmooth(void);
static void decomb(void);

int show_points=0;

 asm("__esp: .long 0\n\t");

void decrypt(void){

// if( (crypt == vc || crypt == nag) && satur!=0 ) decomb();
// decomb();

 if(crypt==vc)       vc_decrypt();
 else if(crypt==nag) nag_decrypt();

 if(one_field==0 && v_smooth==1) vsmooth();

}


static void decomb(void){

 int linep, llinep, line, i, o;
 int j, k;
 int temp[max_x];
 const int yresst1= yresst>>1;

 const int stride=one_field ? (xres<<1) : (xres<<2);
 const int pass=one_field ? 1 : 2;
 const int end=one_field ? yresst : yresst1;

 for(o=0; o<pass; o++){

   for(i=0; i<max_x; i++) temp[i]=0;

   linep=stride * end;
   if(o) linep+=xres<<1;
   for(line=end-1; line>=0; line--){
     linep-=stride;
     for(i=0; i<xress; i++){
       j = int(dispbuf.b[linep  + (i<<1)]);
       k = temp[i] & (~1);
       if(j>127) j= j - 256;
       j=(j + j) - k;
       j-=j>>4;
       temp[i]=j;
     }
   }
  
   linep=-stride;
   if(o) linep+=xres<<1;
   for(line=0; line<end; line++){
     linep+=stride;
     for(i=0; i<xress; i++){
       j = int(dispbuf.b[linep  + (i<<1)]);
       k = temp[i] & (~1);
       if(j>127) j= j - 256;
       j=(j + j) - k;
       dispbuf.b[linep  + (i<<1)] = (char)(j);
       j-=j>>4;
       temp[i] = j;
     }                                               
   }
 }

/*
 asm(//"int $3                    \n\t"
     "1:                          \n\t"
     "movl (%%esi      ), %%eax   \n\t"    //U         LINE-1
     "movl (%%esi,%%edi), %%ebx   \n\t"    // V 1      LINE
     "movl %%ebx, %%ecx           \n\t"    //U
     "andl $0x00FF00FF, %%eax     \n\t"    // V 1
     "andl $0x00FF00FF, %%ebx     \n\t"    //U
     "addl $0x00800080, %%eax     \n\t"    // V 1
     "xorl $0x00800080, %%eax     \n\t"    //U
     "addl %%ebx, %%ebx           \n\t"    // V 1
     "orl  $0x02000200, %%ebx     \n\t"    //U
     "andl $0xFF00FF00, %%ecx     \n\t"    // V 1
     "subl %%eax, %%ebx           \n\t"    //U
     "addl $4, %%esi              \n\t"    // V 1 
     "movl %%ebx, %%eax           \n\t"    //U
     "andl $0x01F801F8, %%ebx     \n\t"    // V 1
     "shrl $3, %%ebx              \n\t"    //U
     "nop                         \n\t"    // V 1 FIX ME
     "addl $0x00600060, %%ebx     \n\t"    //U
     "nop                         \n\t"    // V 1 FIX ME
     "xorl $0x00600060, %%ebx     \n\t"    //U
     "nop                         \n\t"    // V 1 FIX ME
     "subl %%ebx, %%eax           \n\t"    //U
     "nop                         \n\t"    // V 1 FIX ME
     "andl $0x00FF00FF, %%eax     \n\t"    //U
     "nop                         \n\t"    // V 1 FIX ME
     "orl %%ecx, %%eax            \n\t"    //U
     "decl %%edx                  \n\t"    // V 1
     "movl %%eax, -4(%%esi, %%edi)\n\t"    //U
     " jnz 1b                     \n\t"    // V 1

         :
         : "D" (one_field==1 ? (xres<<1) : (xres<<2)), "S" (dispbuf.b),
           "d" (xres * yress>>1)
         : "%eax", "%ebx", "%ecx", "%edx", "%esi");
 */
}

static void vsmooth(void){
/*
     for(int x=0; x < xress; x++){
       dispbuf.rgb[x + y*xres].r=(  (dispbuf.rgb[x +  y   *xres].r >> 1)
                                  + (dispbuf.rgb[x + (y+1)*xres].r     )
                                  + (dispbuf.rgb[x + (y+2)*xres].r >> 1) ) >> 1;
       dispbuf.rgb[x + y*xres].g=(  (dispbuf.rgb[x +  y   *xres].g >> 1)
                                  + (dispbuf.rgb[x + (y+1)*xres].g     )
                                  + (dispbuf.rgb[x + (y+2)*xres].g >> 1) ) >> 1;
       dispbuf.rgb[x + y*xres].b=(  (dispbuf.rgb[x +  y   *xres].b >> 1)
                                  + (dispbuf.rgb[x + (y+1)*xres].b     )
                                  + (dispbuf.rgb[x + (y+2)*xres].b >> 1) ) >> 1;
     }
  */

 if(yuvmode==0){
   asm(//"int $3                      \n\t"
       "1:                          \n\t"
       "movl (%%esi        ), %%eax \n\t"    //U         LINE
       "movl (%%esi,%%edi,2), %%ebx \n\t"    // V 1      LINE + 2
       "shrl $2, %%eax              \n\t"    //U
       "andl $0xFCFCFCFC, %%ebx     \n\t"    // V 1        
       "shrl $2, %%ebx              \n\t"    //U
       "andl $0x3F3F3F3F, %%eax     \n\t"    // V 1
       "addl %%eax, %%ebx           \n\t"    //U
       "movl (%%esi,%%edi  ), %%eax \n\t"    // V 1      LINE + 1
       "shrl $1, %%eax              \n\t"    //U
       "andl $0x7F7F7F7F, %%ebx     \n\t"    // V 1  
       "andl $0x7F7F7F7F, %%eax     \n\t"    //U
       "addl $4, %%esi              \n\t"    // V 1
       "addl %%eax, %%ebx           \n\t"    //U
       "decl %%ecx                  \n\t"    // V 1
       "movl %%ebx, -4(%%esi      ) \n\t"    //U         LINE
       " jnz 1b                     \n\t"    // V 1
           :
           : "D" (xres<<2), "S" (dispbuf.b),
             "c" (xres * (yress-2) ) 
           : "%eax", "%ebx", "%ecx", "%esi");

 }
 else{
   asm(//"int $3                      \n\t"
       "1:                          \n\t"
       "movl (%%esi        ), %%eax \n\t"    //U         LINE
       "movl (%%esi,%%edi,2), %%ebx \n\t"    // V 1      LINE + 2
       "shrl $2, %%eax              \n\t"    //U
       "andl $0xFCFCFCFC, %%ebx     \n\t"    // V 1        
       "shrl $2, %%ebx              \n\t"    //U
       "andl $0x3F3F3F3F, %%eax     \n\t"    // V 1
       "addl $0x00200020, %%eax     \n\t"    //U
       "addl $0x00200020, %%ebx     \n\t"    // V 1
       "xorl $0x00200020, %%eax     \n\t"    //U
       "xorl $0x00200020, %%ebx     \n\t"    // V 1
       "addl %%eax, %%ebx           \n\t"    //U
       "movl (%%esi,%%edi  ), %%eax \n\t"    // V 1      LINE + 1
       "shrl $1, %%eax              \n\t"    //U
       "andl $0x7F7F7F7F, %%ebx     \n\t"    // V 1  
       "andl $0x7F7F7F7F, %%eax     \n\t"    //U
       "addl $0x00400040, %%ebx     \n\t"    // V 1
       "addl $0x00400040, %%eax     \n\t"    //U
       "xorl $0x00400040, %%ebx     \n\t"    // V 1
       "xorl $0x00400040, %%eax     \n\t"    //U
       "addl $4, %%esi              \n\t"    // V 1
       "addl %%eax, %%ebx           \n\t"    //U
       "decl %%ecx                  \n\t"    // V 1
       "movl %%ebx, -4(%%esi      ) \n\t"    //U         LINE
       " jnz 1b                     \n\t"    // V 1
           :
           : "D" (xres<<1), "S" (dispbuf.b),
             "c" (xres * (yress-2) >> 1) 
           : "%eax", "%ebx", "%ecx", "%esi");


 }
}
