//2010 0.1 Copyright (C) Michael Niedermayer 1998

#include <stdlib.h>
#include <string.h>
#include "2_all.h"
#include "2_gfunc.h"

 extern int xres, yres, xresc;
 extern int buttons, xpos, ypos, lxpos, lypos;
 extern int fysize;
 extern byte font[4096];
 extern int me, mx, my;
 extern int g_mode;
 extern int page_flip;
 extern xxx dispbuf;
 extern byte *vidbuf;
 extern int yuvmode;

static inline void memsetd(void *pt, u_long c, int num);

static inline void memsetd(void *pt, u_long c, int num){

 asm(//"int $3 \n\t"
     "rep    \n\t"
     "stosl  \n\t"
     :
     : "a" (c), "D" (pt), "c" (num)
     : "%ecx", "%edi");


}

void xcliped_gprint(int xp, int yp, const s_col c, int text){
 int ix, iy;
 int t3;
 byte t1;

 if(yp>0) iy=0;
 else iy=-yp;
 for(; iy<fysize && (iy+yp<yres); iy++){
   t1=font[(text<<4)+iy];
   t3=xp+(yp+iy)*xres;
   if(xp>0) ix=0;
   else ix=-xp;
   for(; ix<8 && ix+xp<xres; ix++){
     if(((t1>>(7-ix)) & 1) == 1){
       if(yuvmode!=0)
         dispbuf.yuv[(ix+t3)/2]=c.yuv;       //FIX ME
       else
         dispbuf.rgb[(ix+t3)]=c.rgb;      
     }
   }
 }
}

void gprint(int xp, int yp, const s_col c, char *text){
 static int clipyp, clipym;
 int i, t=0, tp=0;

 if(xp<0){
  if(xp+int(strlen(text))*9+1<0) return;
  i=(-xp+1)/9+1;
  if(i>int(strlen(text))) return;
  text+=i;
  xp+=i*9;
  xcliped_gprint(xp-9, yp, c, *(text-1));
 }
 if(yp<0){
  if(yp+fysize<=0) return;
  clipym=-yp;
 }
 else clipym=0;

 if(xp+int(strlen(text))*9+1>=xres){
  if(xp>=xres) return;
  i=(xres-xp)/9;
  t=text[i];
  tp=i;
  text[i]=0;
 }

 if(yp+fysize>yres){
  if(yp>=yres) return;
  clipyp=yres-yp;
 }
 else clipyp=fysize;

 //FIX ME TEST reg, imm is NP

 if(yuvmode!=0){
   asm(//"int $3\n\t"
        "pushl %%ebp               \n\t"
        "pushl %%eax               \n\t"
        "10:                       \n\t"
        "movl %4, %%esi            \n\t"
        "movl %%esi, %%edi         \n\t"
        "imull %1, %%esi           \n\t"
        "popl %%ebp                \n\t"
        "pushl %%ebp               \n\t"
        "movl %%ebp, %%eax         \n\t"
        "shrl $16, %%ebp           \n\t"
        "testl $2, %%edx           \n\t"
        " jz 0f                    \n\t"
        "xchgl %%eax, %%ebp        \n\t"
        "0:                        \n\t"
        "xorl %%ebx,%%ebx          \n\t"     
        "movb (%%ecx), %%bl        \n\t"
        "testb %%bl, %%bl          \n\t"
        " jz 9f                    \n\t"
        "shll $4, %%ebx            \n\t"
        "addl %%edi, %%ebx         \n\t"
        "addl %2, %%ebx            \n\t"
        "movb (%%ebx), %%bl        \n\t"
        "testb $128, %%ebx         \n\t"
        " jz 1f                    \n\t"
        "movw %%ax,  (%%edx,%%esi) \n\t"
        "1:                        \n\t"
        "testb $64, %%bl           \n\t"
        " jz 2f                    \n\t"
        "movw %%bp, 2(%%edx,%%esi) \n\t"
        "2:                        \n\t"
        "testb $32, %%bl           \n\t"
        " jz 3f                    \n\t"
        "movw %%ax, 4(%%edx,%%esi) \n\t"
        "3:                        \n\t"
        "testb $16, %%bl           \n\t"
        " jz 4f                    \n\t"
        "movw %%bp, 6(%%edx,%%esi) \n\t"
        "4:                        \n\t"
        "testb $8, %%bl            \n\t"
        " jz 5f                    \n\t"
        "movw %%ax, 8(%%edx,%%esi) \n\t"
        "5:                        \n\t"
        "testb $4, %%bl            \n\t"
        " jz 6f                    \n\t"
        "movw %%bp,10(%%edx,%%esi) \n\t"
        "6:                        \n\t"
        "testb $2, %%bl            \n\t"
        " jz 7f                    \n\t"
        "movw %%ax,12(%%edx,%%esi) \n\t"
        "7:                        \n\t"
        "testb $1, %%bl            \n\t"
        " jz 8f                    \n\t"
        "movw %%bp,14(%%edx,%%esi) \n\t"
        "8:                        \n\t"
        "incl %%edi                \n\t"
        "addl %1, %%esi            \n\t"
        "cmpl %3, %%edi            \n\t"
        " jb 0b                    \n\t"
        "xchgl %%eax, %%ebp        \n\t"
        "addl $18, %%edx           \n\t"
        "incl %%ecx                \n\t"
        "jmp 10b                   \n\t" 
        "9:                        \n\t" 
        "popl %%eax                \n\t"
        "popl %%ebp                \n\t"
        :
        : "m" (fysize), "m"(xresc), "m" (&font), "m" (clipyp), "m" (clipym),
          "a" (c.yuv), "c" (text), "d" (((u_long)dispbuf.cl)+((xp+yp*xres)<<1))
        : "%ebx", "%ecx", "%edx", "%esi", "%edi");
 }else{
   asm(//"int $3\n\t"
        "10:                       \n\t"
        "movl %4, %%esi            \n\t"
        "movl %%esi, %%edi         \n\t"
        "imull %1, %%esi           \n\t"
        "0:                        \n\t"
        "xorl %%ebx,%%ebx          \n\t"
        "movb (%%ecx), %%bl        \n\t"
        "testb %%bl, %%bl          \n\t"
        " jz 9f                    \n\t"
        "shll $4, %%ebx            \n\t"
        "addl %%edi, %%ebx         \n\t"
        "addl %2, %%ebx            \n\t"
        "movb (%%ebx), %%bl        \n\t"
        "testb $128, %%ebx         \n\t"
        " jz 1f                    \n\t"
        "movl %%eax,  (%%edx,%%esi)\n\t"
        "1:                        \n\t"
        "testb $64, %%bl           \n\t"
        " jz 2f                    \n\t"
        "movl %%eax, 4(%%edx,%%esi)\n\t"
        "2:                        \n\t"
        "testb $32, %%bl           \n\t"
        " jz 3f                    \n\t"
        "movl %%eax, 8(%%edx,%%esi)\n\t"
        "3:                        \n\t"
        "testb $16, %%bl           \n\t"
        " jz 4f                    \n\t"
        "movl %%eax,12(%%edx,%%esi)\n\t"
        "4:                        \n\t"
        "testb $8, %%bl            \n\t"
        " jz 5f                    \n\t"
        "movl %%eax,16(%%edx,%%esi)\n\t"
        "5:                        \n\t"
        "testb $4, %%bl            \n\t"
        " jz 6f                    \n\t"
        "movl %%eax,20(%%edx,%%esi)\n\t"
        "6:                        \n\t"
        "testb $2, %%bl            \n\t"
        " jz 7f                    \n\t"
        "movl %%eax,24(%%edx,%%esi)\n\t"
        "7:                        \n\t"
        "testb $1, %%bl            \n\t"
        " jz 8f                    \n\t"
        "movl %%eax,28(%%edx,%%esi)\n\t"
        "8:                        \n\t"
        "incl %%edi                \n\t"
        "addl %1, %%esi            \n\t"
        "cmpl %3, %%edi            \n\t"
        " jb 0b                    \n\t"
        "addl $36, %%edx           \n\t"
        "incl %%ecx                \n\t"
        "jmp 10b                   \n\t" 
        "9:                        \n\t" 
        :
        : "m" (fysize), "m"(xresc), "m" (&font), "m" (clipyp), "m" (clipym),
          "a" (c.rgb), "c" (text), "d" (((u_long)dispbuf.cl)+((xp+yp*xres)<<2))
        : "%ebx", "%ecx", "%edx", "%esi", "%edi");
   }
 if(t!=0){
  xcliped_gprint(xres - ((xres-xp) % 9), yp, c, t);
  text[tp]=t;
 }
}

void dot(const int x, const int y, const s_col c){

 if(x>0 && x<xres && y>0 && y<yres){
   if(yuvmode!=0){
     dispbuf.cl[y*xres+x].lum=c.yuv.y1;
     dispbuf.cl[(y*xres+x) |   1 ].chrom=c.yuv.v;
     dispbuf.cl[(y*xres+x) & (~1)].chrom=c.yuv.u;
   }else{
     dispbuf.rgb[y*xres+x].r=c.rgb.r;
     dispbuf.rgb[y*xres+x].g=c.rgb.g;
     dispbuf.rgb[y*xres+x].b=c.rgb.b;
   }
 }
}
/*
void line(int x1, int y1, int x2, int y2, const s_yuv c){
 int t;

 if(x1<0){
  if(x2<0) return;
  else y1=(int)((float)(y1-y2)/((float)(x2-x1)+.1E-4)*(float)x2+y2), x1=0;
 }
 else if(x1>=xres){
  if(x2>=xres) return;
  else y1=(int)((float)(y1-y2)/((float)(x2-x1)+.1E-4)*(float)(x2-xres+1)+y2), x1=xres-1;
 }
 if(x2<0) y2=(int)((float)(y2-y1)/((float)(x1-x2)+.1E-4)*(float)x1+y1), x2=0;
 else if(x2>=xres)
    y2=(int)((float)(y2-y1)/((float)(x1-x2)+.1E-4)*(float)(x1-xres+1)+y1), x2=xres-1;
                                            

 if(y1<0){
  if(y2<0) return;
  else x1=(int)((float)(x1-x2)/((float)(y2-y1)+.1E-4)*(float)y2+x2), y1=0;
 }
 else if(y1>=yres){
  if(y2>=yres) return;
  else 
   x1=(int)((float)(x1-x2)/((float)(y2-y1)+.1E-4)*(float)(y2-yres+1)+x2), y1=yres-1;
 }
 if(y2<0) x2=(int)((float)(x2-x1)/((float)(y1-y2)+.1E-4)*(float)y1+x1), y2=0;
 else if(y2>=yres)
    x2=(int)((float)(x2-x1)/((float)(y1-y2)+.1E-4)*(float)(y1-yres+1)+x1), y2=yres-1;

 if(x1==x2 && y1==y2) return;

 if(mabs(x1-x2)>mabs(y1-y2)){
  register int fl,delta;
  if(x1>x2) t=x1,x1=x2,x2=t,t=y1,y1=y2,y2=t,t=1;
  delta=(y1-y2)*(1<<16)/(x1-x2);

  for(fl=y1<<16; x1<x2; x1++){
   fl+=delta;
   dispbuf.yuv[(x1+(fl>>16)*xres)>>1]=c; //FIX ME
  }
 }else {
  register int fl,delta;
  if(y1>y2) t=y1,y1=y2,y2=t,t=x1,x1=x2,x2=t,t=1;
  delta=(x1-x2)*(1<<10)/(y1-y2) + (xres<<10);
  fl=(x1+y1*xres)<<10;
  y2-=y1;
  for(; y2!=0; y2--){
   fl+=delta;
   dispbuf.yuv[(fl>>10)>>1]=c; //FIX ME
  }

 } 
}
  */

void hline(register int x1, int y1, register int x2, const s_yuv c){
 int t;
 u_long *a=(u_long *)(&c);

 if(x1>x2) t=x1, x1=x2, x2=t;
 
 if(x1<0){
  x1=0;
  if(x2<0) return;
 }
 if(x2>=xres){
  x2=xres-1;
  if(x1>=xres) return;
 }
 if(y1<0 || y1>=yres) return;

 x1+=y1*xres;
 memset(dispbuf.cl + x1, *a, ((x2+y1*xres)-x1+1)<<1);  //FIX HLINE
}
/*
void vline(const int x1, register int y1, register int y2, const s_yuv c){
 int t;

 if(y1>y2) t=y1, y1=y2, y2=t;
 
 if(y1<0){
  y1=0;
  if(y2<0) return;
 }
 if(y2>=yres){
  y2=yres-1;
  if(y1>=yres) return;
 }
 if(x1<0 || x1>=xres) return;

 y1=y1*xres+x1;
 y2=(y2-2)*xres+x1;
 for(; y1<y2; y1+=xres){
  dispbuf[y1]=c;
  dispbuf[y1+=xres]=c;
  dispbuf[y1+=xres]=c;
  dispbuf[y1+=xres]=c;
 }
 y2+=xres<<1;
 for(; y1<y2; y1+=xres){
  dispbuf[y1]=c;
 }
}
*/

void rect(int x1, int y1, int x2, int y2, const s_col c){
 u_long *a=(u_long *)(&c.yuv);
 int t;
/*
 if(x1>x2) t=x1,x1=x2,x2=t;
 if(y1>y2) t=y1,y1=y2,y2=t;  */


 if(x1<0){
  if(x2<0) return;
  x1=0;
 }
 else if(x2>=xres){
  if(x1>=xres) return;
  x2=xres-1;
 }
 if(y1<0){
  if(y2<0) return;
  y1=0;
 }
 else if(y2>=yres){
  if(y1>=yres)
  y2=yres-1;
 }
 y1*=xresc;
 y2*=xresc;

 t=x1 & (~1);
 if(yuvmode!=0){
   for(; y1<=y2; y1+=xresc){
     if(x1 & 1 == 1) {}
     memsetd((byte*)dispbuf.cl +y1 +(t<<1), *a, ((x2-x1)>>1));
     if(x2 & 1 == 1) {}
   }
 }else{
   for(; y1<=y2; y1+=xresc){
     memsetd((byte*)dispbuf.cl +y1 +(x1<<2), *a, x2-x1);
   }
 }

}
