//2010 0.1 Copyright (C) Michael Niedermayer 1998

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include "2_all.h"
#include "2_crypt.h"
#include "2_vc.h"
#include "2_nag.h"
#include "2_71x6.h"
#include "2_gfunc.h"
#include "2_mmx.h"
#include "2_nag_a.h"

#define nagra_buff 32

#define check 1

//int check=1;     //grrrrrr nix working

extern xres, yres, xress, yress, yrest, yresst, y_field;
extern xxx dispbuf;
extern volatile int scales_x, scalee_x;
extern volatile int scales_y, scalee_y;
extern int one_field;
extern u_long asm_temp, asm_temp4;
extern int istate;
extern int yuvmode;
extern int mmx;

static int qsort_block(const void *p1, const void *p2);

static int qsort_block(const void *p1, const void *p2){
  return ( (b_inf*)(p1) )->up_limit - ( (b_inf*)(p2) )->up_limit;
}

void nag_decrypt(void){
 char textbuf[9][128];
 color c;
 const int yresst1=yresst>>1;
 const int c2end=int(double(nagra_buff-scales_y+0x10)/double(288-scales_y+0x10-scalee_y) * yresst1 + .5);
 byte copy_buff[max_x<<1];
 int i, j, k;
 int line, line2;
 int linep, linep2;
 l_inf line_inf[max_y];
 b_inf block   [max_y];
 long T1, T2;
 const int check2= (mmx==0) ? check-1 : check;
 union{
   char datbuf[(xress * yresst1 >> check2) + 16]; // + 16 for out of array thingy
   double nixnixnix; // for alignment
 };
 nixnixnix=0; // for error det ):

 const int corr_block= 8000 / ( 3 * ( (xress >> check2 ) + sizeof(l_inf) ) );

 T1=uclock();

// printf("%d\n\n\n", c2end);

 linep=( xres<<2 )*( yresst1 - c2end - 1 );
 linep2=-(xress >> check2 );
 int blockp;
 for(blockp=0; blockp<yresst1; blockp++){
   block[blockp].end[0]=
   block[blockp].end[1]=blockp;
   line_inf[blockp].state=1;
   line_inf[blockp].block=blockp;
   line_inf[blockp].next[0]=
   line_inf[blockp].next[1]=-1;

   linep+=xres<<2;
   linep2+=xress >> check2;
   if(blockp==c2end) linep=xres<<1;

   if(mmx==0){
     asm(//"int $3 \n\t"
         "pushl %%ebp          \n\t"

         "1:                   \n\t"
         "movw (%%edi), %%ax   \n\t"   // U        load 32 byte in L1-cache
         "xorl %%ebx, %%ebx    \n\t"   //  V 1
         "movl %1, %%ebp       \n\t"   // U
         "xorl %%eax, %%eax    \n\t"   //  V 1
         "2:                   \n\t"
         "addl %%eax, %%ebx    \n\t"   // U
         "xorl %%eax, %%eax    \n\t"   //  V 1
         "movb (%%esi), %%al   \n\t"   // U
         "addl $2, %%esi       \n\t"   //  V 1
         "decl %%ebp           \n\t"   // U
         " jnz 2b              \n\t"   //  V 1
         "addl $2, %%edi       \n\t"   // U
         "addl %%eax, %%ebx    \n\t"   //  V 1
         "shrl %0, %%ebx       \n\t"   // U 
         "decl %%edx           \n\t"   //  V 1
         "movw %%bx, -2(%%edi) \n\t"   // U
         " jnz 1b              \n\t"   //  V 1
    
         "popl %%ebp            \n\t"
          : 
          : "I" (check), "i" (1<<check),
            "S" (dispbuf.b + linep + 1) ,
            "d" (xress>>check) ,
            "D" (datbuf + linep2) 
          : "%eax", "%ebx", "%edx", "%esi", "%edi");
   }
   else{
     asm(//"int $3 \n\t"
         "pushl %%ebp          \n\t"

         "1:                   \n\t"
         "movb (%%edi), %%al   \n\t"   // U        load 32 byte in L1-cache
         "xorl %%ebx, %%ebx    \n\t"   //  V 1
         "movl %1, %%ebp       \n\t"   // U
         "xorl %%eax, %%eax    \n\t"   //  V 1
         "2:                   \n\t"
         "addl %%eax, %%ebx    \n\t"   // U
         "xorl %%eax, %%eax    \n\t"   //  V 1
         "movb (%%esi), %%al   \n\t"   // U
         "addl $2, %%esi       \n\t"   //  V 1
         "decl %%ebp           \n\t"   // U
         " jnz 2b              \n\t"   //  V 1
         "incl %%edi           \n\t"   // U
         "addl %%eax, %%ebx    \n\t"   //  V 1
         "shrl %0, %%ebx       \n\t"   // U 
         "decl %%edx           \n\t"   //  V 1
         "movb %%bl, -1(%%edi) \n\t"   // U
         " jnz 1b              \n\t"   //  V 1
    
         "popl %%ebp            \n\t"
          : 
          : "I" (check), "i" (1<<check),
            "S" (dispbuf.b + linep + 1) ,
            "d" (xress>>check) ,
            "D" (datbuf + linep2) 
          : "%eax", "%ebx", "%edx", "%esi", "%edi");

   }
 }

 if(istate==1){
   T2=uclock();
   sprintf(textbuf[8],"%f ReSample", (float)(T2-T1)/UCLOCKS_PER_SEC);
   T1=T2;
 }

 for(i=0; i<yresst1; i++){               
   for(j=0; j<l_ent; j++){
     line_inf[i].coeff[j]= 0x7FFFFFF;
//     line_inf[i].line[j]= 1;
   }
 }

 int corr_loops=0;
 long T_corr=0, T_merge=0;
 int blockpl;
 do{
   blockpl= blockp;
   for(i=0; i<max_y; i++){
     const int temp=line_inf[i].coeff[l_ent-1];       
     for(j=0; j<l_ent; j++){
       line_inf[i].coeff[j]=temp + (temp>>1) ;
     }
   }

   int s_line, s_line2;
   int s_linep, s_linep2;

   s_linep= -((xress >> check2) * (corr_block + 1) );
   for(s_line= 0; s_line < yresst1; s_line += corr_block){
     s_linep2 = s_linep;
     s_linep += (xress >> check2) * corr_block;

     for(s_line2= s_line; s_line2 < yresst1; s_line2 += corr_block){
       s_linep2 += (xress >> check2) * corr_block;

       linep = s_linep;
       for(line= s_line; line < yresst1 && line < (s_line + corr_block); line++){
         linep += xress >> check2;

         if(line_inf[line].state == 0) continue;

         if(s_line == s_line2){
           linep2 = linep;
           line2 = line + 1;
         }
         else{
           linep2 = s_linep2;
           line2 = s_line2;
         }

         asm_temp=(u_long)(line_inf + line);
         asm_temp4=line;

         nagra_corr((yresst1 < (s_line2  + corr_block) ) ?
                     yresst1 : (s_line2  + corr_block),
                    xress >> check2,
                    linep,
                    linep2,
                    line2,
                    int(line_inf),
                    int(datbuf)                             );
       }
     }
   }

   j=100000 / ( xress>>check );
   for(i=0; i<yresst1; i++){
     const int x1 = line_inf[i].coeff[0      ] * j;
     const int x2 = line_inf[i].coeff[l_ent-1] * j;
     if(x1+x2 < 500000 && x2-x1 < 30000) line_inf[i].state=0;
   }

   if(mmx!=0) asm("emms  \n\t");

   if(istate==1){
     T2=uclock();
     T_corr+=T2-T1;
     T1=T2;
   }

   int did_some;
   do{
     did_some=0;

//   printf("START\n\n");

     for(int blocki=0; blocki<blockp; blocki++){
       if(line_inf[ block[blocki].end[0] ].state == 0) continue;

       int endlinei[2]={l_ent, l_ent};
       for(i=0; i<l_ent; i++){
         if( endlinei[0]==l_ent &&
             line_inf[ line_inf[ block[blocki].end[0] ].line[i] ].state != 0 &&
                       line_inf[ block[blocki].end[0] ].line[i] != block[blocki].end[1] ){
           endlinei[0]=i;
         }  
         if( endlinei[1]==l_ent &&
             line_inf[ line_inf[ block[blocki].end[1] ].line[i] ].state != 0 &&
                       line_inf[ block[blocki].end[1] ].line[i] != block[blocki].end[0] ){
           endlinei[1]=i;
         }  
       }
  
       if(endlinei[0]==l_ent && endlinei[1]==l_ent){
//         printf("noLines!\n");
         continue;
       }
               // can't handle line + block 
       if(block[blocki].end[0] == block[blocki].end[1]
          && line_inf[ line_inf[ block[blocki].end[0] ].line[ endlinei[0] ]
                      ].state == 2)
         continue;
  
       int endi=0;
       if(endlinei[0]==l_ent || ( endlinei[1]!=l_ent &&
            line_inf[ block[blocki].end[0] ].coeff[ endlinei[0] ] >
            line_inf[ block[blocki].end[1] ].coeff[ endlinei[1] ]   ) ) endi=1;
       if(endlinei[0]==l_ent || endlinei[1]==l_ent ||
          block[blocki].end[0] == block[blocki].end[1]) i=1;
       else                                             i=0;
       for(; i<2; i++){
         const int line1= block[blocki].end[endi];
         const int line2= line_inf[line1].line[ endlinei[endi] ];
  
         const int block2= line_inf[line2].block;    //FIX THIS (CRASHED)
         const int endi2= block[block2].end[0] == line2 ? 0 : 1;   //FIX THIS CRASHED 
  
         int backlinei[2]={l_ent, l_ent};
         for(j=0; j<l_ent; j++){
           if( backlinei[0]!=l_ent && 
               line_inf[ line_inf[ line2 ].line[j] ].state != 0 &&
               line_inf[ line2 ].line[j] != block[block2].end[endi2 ^ 1] ){
             backlinei[1]=j;
             break;
           }  
           if( backlinei[0]==l_ent && 
               line_inf[ line_inf[ line2 ].line[j] ].state != 0 &&
               line_inf[ line2 ].line[j] != block[block2].end[endi2 ^ 1] ){
             backlinei[0]=j;
             if(line_inf[ line2 ].line[j] == line1) break;
           }  
         }
         if(backlinei[1] == l_ent) backlinei[1] = backlinei[0];

         else if( line_inf[line2].state == 1 &&
                  line_inf[line2].line[ backlinei[1] ] == line1 ){

           const int line3=  line_inf[ line2 ].line[ backlinei[0] ];
           const int block3= line_inf[ line3 ].block;
           const int endi3=  block[block3].end[0] == line3 ? 0 : 1;
           for(j=0; j<l_ent; j++){
             if( line_inf[ line_inf[ line3 ].line[j] ].state != 0 &&
                 line_inf[ line3 ].line[j] != block[block3].end[endi3 ^ 1] ){
               if(line_inf[ line3 ].line[j] == line2) backlinei[0]= l_ent;
               break;
             }  
           }
         }

         if(backlinei[0] == l_ent){
//           printf("noLines2!\n");
           continue;
         }

         if(line_inf[line2].line[ backlinei[0] ] == line1 ||
            ( line_inf[line2].state == 1 &&
              line_inf[line2].line[ backlinei[1] ] == line1 ) ){
     
//           printf("%d %d  %d %d  %d %d  %d %d\n", line1, line2, blocki, block2,
//           line_inf[line1].state, line_inf[line2].state,
//           block[blocki].end[0], block[blocki].end[1]);
     
//           printf("%d %d  %d %d\n",
//           line_inf[line1].next[1], line_inf[line1].next[0],
//           line_inf[line2].next[1], line_inf[line2].next[0]);

           did_some=1;

           line_inf[line1].state++;
           line_inf[line2].state++;
           if(line_inf[line1].state == 3) line_inf[line1].state= 0;
           if(line_inf[line2].state == 3) line_inf[line2].state= 0;

           line_inf[line1].next[1] = line_inf[line1].next[0];
           line_inf[line2].next[1] = line_inf[line2].next[0];

           line_inf[line1].next[0] = line2;
           line_inf[line2].next[0] = line1;

//           printf("%d %d  %d %d\n",
//           line_inf[line1].next[1], line_inf[line1].next[0],
//           line_inf[line2].next[1], line_inf[line2].next[0]);

           if(blocki != blockp-1){
             line_inf[ block[blockp-1].end[0] ].block = block2;
             line_inf[ block[blockp-1].end[1] ].block = block2;

             line_inf[ block[block2].end[endi2 ^ 1] ].block = blocki;
 
             block[blocki].end[endi]= block[block2].end[endi2 ^ 1];

             block[block2]= block[blockp - 1];
           }
           else{

             line_inf[ block[blocki].end[endi ^ 1] ].block = block2;

             block[block2].end[endi2]= block[blocki].end[endi ^ 1];
           }
 
           blockp--;
 
 

           break;
         }
         endi ^= 1;
       }

     }

   } while(did_some!=0);

   if(istate==1){
     T2=uclock();
     T_merge+=T2-T1;
     T1=T2;
   }

   corr_loops++;

 } while( blockpl > blockp*3  &&  corr_loops < 2);

// printf("\n%d\n\n", blockp);

 if(istate==1){
   sprintf(textbuf[0],"%f Corr", (float)(T_corr)/UCLOCKS_PER_SEC);
   sprintf(textbuf[1],"%f Block Handling", (float)(T_merge)/UCLOCKS_PER_SEC);
   T2=uclock();
   T1=T2;
 }


 for(i=0; i<blockp; i++){
   line= block[i].end[0];
   line2=-1;

   int avg=0;
   int num=0;
   int up_limit=0, up_limit2=0;
   while(0==0){
     avg+=line;
     if(line - num >= up_limit ){
       up_limit  = line - num;
     }
     if(line + num >= up_limit2){
       up_limit2  = line + num;
     }
     num++;
     if(line_inf[line].next[0] == line2){
       line2=line;
       line= line_inf[line].next[1];
     }
     else{
       line2=line;
       line= line_inf[line].next[0];
     }
     if(line == -1) break;
   }

   up_limit2 -=num;

   avg/=num;
//   printf("%d %d    %d %d\n", num, avg,  up_limit,  up_limit2);
   if(up_limit > up_limit2){
     line= block[i].end[1];
     block[i].end[0]= line;
     block[i].end[1]= block[i].end[0];
     up_limit=up_limit2;
   }
   up_limit -= c2end + 6;

   if( up_limit < 0 ) up_limit=0;
   if( up_limit + num > yresst1 ) up_limit=0;  // FIX ME ?

   if( up_limit > avg ) up_limit = 0;

   block[i].up_limit=up_limit;
   block[i].down_limit=yresst1;
   block[i].avg=avg;
   block[i].ent=num;

 }

 if(istate==1){
   T2=uclock();
   sprintf(textbuf[2],"%f Stat", (float)(T2-T1)/UCLOCKS_PER_SEC);
   T1=T2;
 }

 qsort(block, blockp, sizeof(b_inf), qsort_block);

 if(istate==1){
   T2=uclock();
   sprintf(textbuf[3],"%f Sort", (float)(T2-T1)/UCLOCKS_PER_SEC);
   T1=T2;
 }

 int forw_vec[yrest];
 int bakw_vec[yrest];

 for(i=0; i<yrest; i++){
   forw_vec[i]=
   bakw_vec[i]=-1;
 }

 int sline=0;
 for(i=0; i<blockp; i++){
   line= block[i].end[0];
   line2=-1;
   int tline;
   while(0==0){
     if(line_inf[line].next[0] == line2){
       line2=line;
       line= line_inf[line].next[1];
     }
     else{
       line2=line;
       line= line_inf[line].next[0];
     }
     if(line2 < c2end) tline=  (line2 + yresst1 - c2end)<<1;
     else              tline=( (line2 - c2end          )<<1 ) + 1;

     if(forw_vec[tline] != -1) printf("fatal forw %d\n", tline);
     if(bakw_vec[sline] != -1) printf("fatal bakw %d\n", sline);

     forw_vec[tline] = sline;
     bakw_vec[sline] = tline;

     if(yres == yrest) sline +=2;
     else              sline ++;

     if(line == -1) break;
   }
 }

 if(istate==1){
   T2=uclock();
   sprintf(textbuf[4],"%f Built Vecs", (float)(T2-T1)/UCLOCKS_PER_SEC);
   T1=T2;
 }


 for(i=0; i<yrest; i++){
   if(bakw_vec[i] == -1 || bakw_vec[i] == i) continue;
   j=i;
   do{
     k = j;
     j = forw_vec[j];
   } while(j != i && j != -1);
   const int open= ( (j == -1)   ?    1 : 0 );

   if(open == 0){
     memcpy(copy_buff, dispbuf.cl + i * xres, xress << 1);
     j = i;
     do{
       k = j;
       j = bakw_vec[j];
       forw_vec[k] = k;
       bakw_vec[k] = k;
//       printf("closed %d %d\n", j, k );
       if(j != i)  memcpy(dispbuf.cl + k * xres, dispbuf.cl + j * xres, xress << 1);
     } while(j != i);
     memcpy(dispbuf.cl + k * xres, copy_buff, xress << 1);
   }
   else{
     j = k;
     do{
       k = j;
       j = bakw_vec[j];
       forw_vec[k] = k;
       bakw_vec[k] = k;
//       printf("open %d %d\n", j, k );
       if(j != -1) memcpy(dispbuf.cl + k * xres, dispbuf.cl + j * xres, xress << 1);
     } while(j != -1);
   }

 }

 if(yrest == yres){
   for(i=0; i<yrest; i+=2){
     memcpy(dispbuf.cl + (i+1) * xres, dispbuf.cl + i * xres, xress << 1);
   }
 }

/*
 linep=0;
 for(line=0; line<yresst1; line++){
   linep+=xres<<1;
   int allnor=0;
   int allinv=0;
   for(i=0; i<xress; i+=2){
     register int x=dispbuf.b[ linep + (i<<1) - (xres<<1) + 2 ];
     register int y=dispbuf.b[ linep + (i<<1)             + 2 ];
     if(x>127) x-=256;
     if(y>127) y-=256;
     allnor+=mabs(x-y);
     allinv+=mabs(x+y);
   }
   if(allinv < allnor){
     dispbuf.cl[line  * xres + 4          ].lum=255;
     dispbuf.cl[line  * xres + 5          ].lum=0;
     for(i=0; i<xress; i+=2){
       register int x=dispbuf.b[ linep + (i<<1) + 2 ];
       if(x>127) x-=256;
       dispbuf.b[ 2 + linep + (i<<1) ]=char(-x);
     } 
   }

 }

 linep=0;
 for(line=0; line<yresst1; line++){
   linep+=xres<<1;
   int allnor=0;
   int allinv=0;
   for(i=0; i<xress; i+=2){
     register int x=dispbuf.b[ linep + (i<<1) - (xres<<1) ];
     register int y=dispbuf.b[ linep + (i<<1)             ];
     if(x>127) x-=256;
     if(y>127) y-=256;
     allnor+=mabs(x-y);
     allinv+=mabs(x+y);
   }
   if(allinv < allnor){
     dispbuf.cl[line  * xres + 6          ].lum=255;
     dispbuf.cl[line  * xres + 7          ].lum=0;
     for(i=0; i<xress; i+=2){
       register int x=dispbuf.b[ linep + (i<<1) ];
       if(x>127) x-=256;
       dispbuf.b[ linep + (i<<1) ]=char(-x);
     } 
   }

 }
*/  
 if(istate==1){
   T2=uclock();
   sprintf(textbuf[5],"%f Move", (float)(T2-T1)/UCLOCKS_PER_SEC);
   sprintf(textbuf[6],"%d Blocks", blockp);
   sprintf(textbuf[7],"%d Loops", corr_loops);
   c.init(255, 0, 0, yuvmode);
   gprint(80,  80,  c.c, textbuf[0]);
   gprint(90,  90,  c.c, textbuf[1]);
   gprint(100, 100, c.c, textbuf[2]);
   gprint(110, 110, c.c, textbuf[3]);
   gprint(120, 120, c.c, textbuf[4]);
   gprint(130, 130, c.c, textbuf[5]);
   gprint(140, 140, c.c, textbuf[6]);
   gprint(150, 150, c.c, textbuf[7]);
   gprint(160, 160, c.c, textbuf[8]);
   T1=T2;
 }

 line=0;
 for(i=0; i<blockp; i++){
//   printf("%d %d %d\n", i, block[i].up_limit, block[i].avg);
   line+= block[i].ent;

   dispbuf.cl[line  * xres              ].lum=255;
   dispbuf.cl[line  * xres + 1          ].lum=0;
   if(line_inf[ block[i].end[0] ].state == 0){
     dispbuf.cl[line  * xres + 2          ].lum=255;
     dispbuf.cl[line  * xres + 3          ].lum=0;
   }
 }
}

