//2010 0.1 Copyright (C) Michael Niedermayer 1998

#include <stdio.h>
#include <time.h>
#include <string.h>
#include "2_all.h"
#include "2_crypt.h"
#include "2_vc.h"
#include "2_71x6.h"
#include "2_gfunc.h"
#include "2_vc_a.h"

#define addap_start 16
#define addap_end 2
#define vc_dead 7.5
#define check 1

extern xres, yres, xress, yress;
extern xxx dispbuf;
extern volatile int scales_x, scalee_x;
extern volatile int scales_y, scalee_y;
extern int one_field;
extern int show_points;
extern int istate;
extern int yuvmode;
extern int edge_lut[256];


static int *new_val=new int[max_x], *last_val=new int[max_x];

static byte copy_buff[max_x<<1];


void vc_decrypt(void){
 int i, j, k=0, l;
 int line, cutp, diff, linep, llinep, add_step, start_step;
 int edgep;
 int bestp=0, bestdiff;
 int diffall;
 int temp;
 int cutpoint[max_y];
 int addap_buff[max_x];
 int drift;
 int best_edge=0;
 int best_val, best_edge_val;
 int best_dir=0;
 char textbuf[9][128];
 long T1=0, T2;
 long alg1=0, alg2=0, alg3=0;
 color c;

 const int vc_endx=xress;
 const int vc_startx=int(double(22-scales_x+3)/double(768-scales_x+3-scalee_x)*xress);

 const int vc_diff=vc_endx - vc_startx;

 int *dir=new int[vc_diff*(yress + 1)];

 const int mindist=int(double(vc_diff) / vc_dead);

 cutpoint[0]=0;

 char *datbuf[2];

 datbuf[0]= new char[vc_diff];
 datbuf[1]= new char[vc_diff];

 if(istate==1){
   T1=uclock();
 }

 for(i = 0; i < vc_diff; i++) last_val[i]=1;

 llinep=-(xres<<2);
 linep=-(xres<<1);
 edgep=0;
 for(line=0; line<yress; line++){
   llinep+=xres<<1;
   linep+=xres<<1;
   bestdiff=0x1FFFFFFF;
   diffall=0;
   start_step=0;

   char *dtemp = datbuf[0];
   datbuf[0] = datbuf[1];
   datbuf[1] = dtemp;

   asm(//"int $3 \n\t"
       "pushl %%ebp          \n\t"

       "1:                   \n\t"
       "movw (%%edi), %%ax   \n\t"   // U        load 32 byte in L1-cache
       "xorl %%ebx, %%ebx    \n\t"   //  V 1
       "movl %1, %%ebp       \n\t"   // U
       "xorl %%eax, %%eax    \n\t"   //  V 1
       "2:                   \n\t"
       "addl %%eax, %%ebx    \n\t"   // U
       "xorl %%eax, %%eax    \n\t"   //  V 1
       "movb (%%esi), %%al   \n\t"   // U
       "addl $2, %%esi       \n\t"   //  V 1
       "decl %%ebp           \n\t"   // U
       " jnz 2b              \n\t"   //  V 1
       "addl $2, %%edi       \n\t"   // U
       "addl %%eax, %%ebx    \n\t"   //  V 1
       "shrl %0, %%ebx       \n\t"   // U 
       "decl %%edx           \n\t"   //  V 1
       "movw %%bx, -2(%%edi) \n\t"   // U
       " jnz 1b              \n\t"   //  V 1
  
       "popl %%ebp            \n\t"
        : 
        : "I" (check), "i" (1<<check),
          "S" (dispbuf.b + linep + 1 + (vc_startx<<1)) ,
          "d" (vc_diff>>check) ,
          "D" (datbuf[1]) 
        : "%eax", "%ebx", "%edx", "%esi", "%edi");


   if(istate==1){
     T2=uclock();
     alg3+=T2-T1;
     T1=T2;
   }

   if(line==0) continue;

   for(add_step=addap_start; add_step>addap_end; add_step>>=1){
     start_step>>=1;
     if(add_step==(addap_start>>1) && start_step==0){
       add_step=addap_start;
       start_step=addap_start>>1;
     }
     for(cutp=start_step; cutp<vc_diff; cutp+=add_step){
       if(cutp==start_step || start_step==0 || cutp+add_step>=vc_diff
          || bestdiff+(bestdiff>>1) > addap_buff[cutp - (add_step>>1)]
          || bestdiff+(bestdiff>>1) > addap_buff[cutp + (add_step>>1)]){


         diff = vc_corr(
               int(datbuf[1] + (((                  + cutp) << (1-check))&~1)),
               int(datbuf[0] + ((( - cutp + vc_diff + cutp) << (1-check))&~1)),
                  -(( cutp << (1-check) ) & ~1),
               int(datbuf[1] + (((   cutp + vc_diff - cutp) << (1-check))&~1)),
               int(datbuf[0] + (((        + vc_diff - cutp) << (1-check))&~1)),
                  -(( (vc_diff-cutp) << (1-check) ) & ~1) ) ;

         if(bestdiff>diff){
           bestdiff=diff;
           bestp=cutp;
         }
         addap_buff[cutp]=diff;
         if(start_step==0) diffall+=diff;
       }
       else addap_buff[cutp]=0x7FFFFFFF;
     }
   }
   bestp+= cutpoint[line-1];
   if(bestp>=vc_diff) bestp-=vc_diff;
   cutpoint[line]=bestp;
   if(bestdiff==0) bestdiff++;
   temp=diffall * addap_start * 32 / (vc_diff * bestdiff);
        if(temp<42) drift=xress;
   else if(temp<56) drift=addap_end;
   else             drift=(addap_end>>1) | 1;


   if(istate==1){
     T2=uclock();
     alg1+=T2-T1;
     T1=T2;
   }

   edgep +=vc_diff;

   best_edge_val=0;

   for(i = 0; i < vc_diff; i++){
     l= i + cutpoint[line];
     if(l >= vc_diff) l-=vc_diff;
     if(l < mindist || l >= vc_diff - mindist){
       new_val[i]=0;
       dir[edgep + i]=best_edge;    //FIX ME (not nes)
     }
     else if(drift==xress){
       new_val[i]=1;
       dir[edgep + i]=best_edge;
     }
     else{

       diff=0;
       int edge_x= l == 0 ? (l - 2) + vc_diff : (l - 2);
       do{
         if((edge_x++) >= vc_diff) edge_x-= vc_diff;
         diff+= dispbuf.b[linep + ((vc_startx + edge_x)<<1) + 1];
       }while( edge_x != l );
       do{
         if((edge_x++) >= vc_diff) edge_x-= vc_diff;
         diff-= dispbuf.b[linep + ((vc_startx + edge_x)<<1) + 1];
       }while( edge_x != l + 2);

       diff= edge_lut[ mabs(diff) ];

       new_val[i]= diff;

       best_val=0;

       for(j = i - (drift<<2); j <  i + (drift<<2); j++){
         k=j;
         int drift_p;
         const int drift_t=mabs(j - i);
              if(drift_t <=     1   ) drift_p= 0;
         else if(drift_t <= drift   ) drift_p= 2;
         else if(drift_t <= drift<<1) drift_p=10;
         else if(drift_t <= drift*3 ) drift_p=20;
         else                         drift_p=40;

              if(k <  0      ) k+= vc_diff;
         else if(k >= vc_diff) k-= vc_diff;

         if(last_val[k] - drift_p > best_val){
           best_val=last_val[k] - drift_p;
           best_dir=k;
           if(best_edge_val < best_val){
             best_edge_val=best_val;
             best_edge=best_dir;
           }
         }

       }

       if(best_val!=0){
         new_val[i]+= best_val;
         dir[edgep + i]= best_dir;
       }else{
         new_val[i]=0;
         dir[edgep + i]= 0;    //FIX ME (Not Nes)
         for(j=k+1; i<vc_diff ; j++){
           if(j >= vc_diff) j-=vc_diff;
           if(last_val[j]==0){
             i++;
             l= i + cutpoint[line];
             if(l >= vc_diff) l-=vc_diff;
             new_val[i]=0;
             dir[edgep + i]= 0;    //FIX ME (Not Nes)
           }
           else break;
         }              
         if(i >=  vc_diff && best_edge_val==0){
           i=0;
           drift=xress;
         }
       }
     }
   }

   int *temp_val=last_val;
   last_val=new_val;
   new_val=temp_val;

   if(istate==1){
     T2=uclock();
     alg2+=T2-T1;
     T1=T2;
   }

 }

 if(istate==1){
   T2=uclock();
   sprintf(textbuf[0],"%f Corr", (float)(alg1)/UCLOCKS_PER_SEC);
   sprintf(textbuf[1],"%f Edge-Search", (float)(alg2)/UCLOCKS_PER_SEC);
   sprintf(textbuf[2],"%f ReSample", (float)(alg3)/UCLOCKS_PER_SEC);
   T1=T2;
 }

 i=best_edge;
 for(line=yress-1; line>0; line--){
   if(show_points==0){
     cutpoint[line]+=i;
     if(cutpoint[line] >= vc_diff) cutpoint[line]-= vc_diff;
   }
   else{
     j=cutpoint[line]+i;
     if(j >= vc_diff) j-= vc_diff;
     dispbuf.b[(line * xres<<1) + ((vc_startx + j)<<1)+1]=255;
     dispbuf.b[(line * xres<<1) + ((vc_startx + j)<<1)+3]=0;
   }
   i=dir[vc_diff*line + i];
 }

 if(istate==1){
   T2=uclock();
   sprintf(textbuf[3],"%f Misc", (float)(T2-T1)/UCLOCKS_PER_SEC);
   T1=T2;
 }

 linep=-(xres<<1);
// vc_diff&= ~1;
 for(line=0; line<yress; line++){

//   cutpoint[line]&= ~1;

   linep+=xres<<1;
   if(show_points!=0){
     dispbuf.b[linep+(vc_startx<<1)+1]=255;
     dispbuf.b[linep+(vc_startx<<1)+3]=0;
   }
   memcpy(copy_buff, dispbuf.b + linep + (vc_startx<<1), vc_diff<<1);
   memcpy(dispbuf.b + linep + (vc_startx<<1), copy_buff + (cutpoint[line]<<1),
                                                 (vc_diff-cutpoint[line])<<1);
   memcpy(dispbuf.b + linep + (vc_startx<<1) + ((vc_diff-cutpoint[line])<<1),
                                                                   copy_buff,
                                                         cutpoint[line]<<1);
/*
   if(show_points!=0){
     for(i=0; i<vc_diff; i++){
       j=dir[line * vc_diff + i];
       if(j<0 || j>=vc_diff) j=0;

       dispbuf.b[linep + ((vc_startx + j) <<1)+1]=255;
     }
   }   
     */
 }

 if(istate==1){
   T2=uclock();
   sprintf(textbuf[4],"%f Rotate", (float)(T2-T1)/UCLOCKS_PER_SEC);
   c.init(255, 0, 0, yuvmode);
   gprint(80,  80,  c.c, textbuf[0]);
   gprint(90,  90,  c.c, textbuf[1]);
   gprint(100, 100, c.c, textbuf[2]);
   gprint(110, 110, c.c, textbuf[3]);
   gprint(120, 120, c.c, textbuf[4]);
   T1=T2;
 }


  delete [] dir;
  delete [] datbuf[0];
  delete [] datbuf[1];
}

